// Server.java

import java.util.*;

class AccountImpl implements Bank.AccountOperations {
  AccountImpl(float balance) {	
    _balance = balance;
  }
  public float balance() {
    return _balance;
  }
  private float _balance;
}

class AccountManagerImpl implements Bank.AccountManagerOperations {

  private org.omg.CORBA.BOA _boa; 

  public AccountManagerImpl(org.omg.CORBA.BOA boa) {
    _boa = boa;
  }

  public Bank.Account open(String name) {
    // lookup the account in the account dictionary
    Bank.Account account = (Bank.Account) _accounts.get(name);
    if(account == null) {
      // create a new account with 0-1000 dollars!
      float balance = Math.abs(_random.nextInt()) % 100000 / 100f;
      AccountImpl new_account = new AccountImpl(balance);
      // create the tie object for the account 
      account = new Bank._tie_Account(new_account);
      // export the object reference
      _boa.obj_is_ready(account);
      System.out.println("Created " + name + "'s account: " + account);
      // save the account in the account dictionary
      _accounts.put(name, account);
    }
    return account;
  }
  private Dictionary _accounts = new Hashtable();
  private Random _random = new Random();
}

public class Server {
  public static void main(String[] args) {
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);
      org.omg.CORBA.BOA boa = orb.BOA_init();
      // create the account manager 
      AccountManagerImpl new_manager = 
	new AccountManagerImpl(boa);
      Bank.AccountManager manager 
	= new Bank._tie_AccountManager(new_manager,"BankManager");
      // export the object reference
      boa.obj_is_ready(manager);
      System.out.println(manager + " is ready.");
      // wait for requests
      boa.impl_is_ready();
  }
}


