// PrinterManagerImpl.java

import java.util.*;

public class PrinterManagerImpl extends Printer._PrinterManagerImplBase {
  private com.visigenic.vbroker.orb.ORB _orb;
  public PrinterManagerImpl(com.visigenic.vbroker.orb.ORB orb, String name) {
    super(name);
    _orb = orb;
  }
  public synchronized void printAny(org.omg.CORBA.Any info) {
    // Display info with the assumption that we don't have
    // any info statically about the type inside the any 

    // Create a DynAny object
    org.omg.CORBA.DynAny dynAny = org.omg.CORBA.ORB.init().create_dyn_any(info); 
    try {
      display(dynAny);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    
  }

  public void shutdown() {
    _boa().deactivate_obj(this); 
    System.out.println("Server shutting down");
    _orb.shutdown();
  }

  private void display(org.omg.CORBA.DynAny value) throws Exception {
    switch(value.type().kind().value()) {
      case org.omg.CORBA.TCKind._tk_null:
      case org.omg.CORBA.TCKind._tk_void: {
       break;
      }
      case org.omg.CORBA.TCKind._tk_short: {
        System.out.println(value.get_short());
        break;
      }
      case org.omg.CORBA.TCKind._tk_ushort: {
        System.out.println(value.get_ushort());
        break;
      }
      case org.omg.CORBA.TCKind._tk_long: {
        System.out.println(value.get_long());
        break;
      }
      case org.omg.CORBA.TCKind._tk_ulong: {
        System.out.println(value.get_ulong());
        break;
      }
      case org.omg.CORBA.TCKind._tk_float: {
        System.out.println(value.get_float());
        break;
      }
      case org.omg.CORBA.TCKind._tk_double: {
        System.out.println(value.get_double());
        break;
      }
      case org.omg.CORBA.TCKind._tk_boolean: {
        System.out.println(value.get_boolean());
        break;
      }
      case org.omg.CORBA.TCKind._tk_char: {
        System.out.println(value.get_char());
        break;
      }
      case org.omg.CORBA.TCKind._tk_octet: {
        System.out.println(value.get_octet());
        break;
      }
      case org.omg.CORBA.TCKind._tk_string: {
        System.out.println(value.get_string());
        break;
      }
      case org.omg.CORBA.TCKind._tk_any: {
        org.omg.CORBA.DynAny dynAny = org.omg.CORBA.ORB.init().create_dyn_any(value.get_any()); 
        display(dynAny);
        break;
      }
      case org.omg.CORBA.TCKind._tk_TypeCode: {
        System.out.println(value.get_typecode());
        break;
      }
      case org.omg.CORBA.TCKind._tk_objref: {
        System.out.println(value.get_reference());
        break;
      }
      case org.omg.CORBA.TCKind._tk_enum: {
        org.omg.CORBA.DynEnum dynEnum = org.omg.CORBA.DynEnumHelper.narrow(value);
        System.out.println(dynEnum.value_as_string());
        break;
      }
      case org.omg.CORBA.TCKind._tk_union: {
        org.omg.CORBA.DynUnion dynUnion = org.omg.CORBA.DynUnionHelper.narrow(value);
        display(dynUnion.discriminator());
        display(dynUnion.member());
        break;
      }
      case org.omg.CORBA.TCKind._tk_struct:
      case org.omg.CORBA.TCKind._tk_array:
      case org.omg.CORBA.TCKind._tk_sequence: {
        value.rewind();
        boolean next = true; 
        while(next) {
          org.omg.CORBA.DynAny d = value.current_component();
          display(d);
          next = value.next();
        }
        break;
      }
      case org.omg.CORBA.TCKind._tk_longlong: {
        System.out.println(value.get_longlong());
        break;
      }
      case org.omg.CORBA.TCKind._tk_ulonglong: {
        System.out.println(value.get_ulonglong());
        break;
      }
      case org.omg.CORBA.TCKind._tk_wstring: {
        System.out.println(value.get_wstring());
        break;
      }
      case org.omg.CORBA.TCKind._tk_wchar: {
        System.out.println(value.get_wchar());
        break;
      }
      default:
        System.out.println("Invalid type");
      
    }
  }
}

