package Encryption;

import java.util.*;
import org.omg.CORBA.*;
import org.omg.CORBA.ORBPackage.*;
import com.visigenic.vbroker.interceptor.*;

public class Init extends com.visigenic.vbroker.orb.ServiceInit
{
  // Number of interceptors to chain together.
  private static int NUM_INTERCEPTORS = 5;

  public void init (ORB orb, Properties props) 
  {
    com.visigenic.vbroker.orb.ORB _orb = (com.visigenic.vbroker.orb.ORB) orb;

    // Install client interceptors
    try {
      org.omg.CORBA.Object obj = 
	orb.resolve_initial_references("ChainClientInterceptorFactory");
      ChainClientInterceptorFactory clientFactory = 
	ChainClientInterceptorFactoryHelper.narrow(obj);

      // Chain interceptors together
      for (int i = 0; i < NUM_INTERCEPTORS; i++) {
	clientFactory.add(new CryptoClientInterFactory(_orb));
      }
    } catch (InvalidName e) {
      throw new INITIALIZE("Client interceptor factory is not installed");
    }

    // Install server interceptors
    try {
      org.omg.CORBA.Object obj = 
	orb.resolve_initial_references("ChainServerInterceptorFactory");
      ChainServerInterceptorFactory serverFactory = 
	ChainServerInterceptorFactoryHelper.narrow(obj);

      // Chain interceptors together
      for (int i = 0; i < NUM_INTERCEPTORS; i++) {
	serverFactory.add(new CryptoServerInterFactory(_orb));
      }
    } catch (InvalidName e) {
      throw new INITIALIZE("Server interceptor factory is not installed");
    }
  }
}
