//  Init.java

package sample;

import  java.util.*;

public class Init extends com.visigenic.vbroker.orb.ServiceInit
{
    public void init(org.omg.CORBA.ORB orb, Properties properties)
    {
        System.out.println("Installing Sample Interceptors");

        // install bind interceptor
        try
        {
            com.visigenic.vbroker.interceptor.ChainBindInterceptor bind = 
		com.visigenic.vbroker.interceptor.ChainBindInterceptorHelper.narrow(orb.resolve_initial_references("ChainBindInterceptor"));
            bind.add(new SampleBindInterceptor());
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName e)
        {
            throw new org.omg.CORBA.INITIALIZE("Bind interceptor is not installed: " + e);
        }

        // install client interceptor factory
        try
        {
            com.visigenic.vbroker.interceptor.ChainClientInterceptorFactory clientFactory = com.visigenic.vbroker.interceptor.ChainClientInterceptorFactoryHelper.narrow(orb.resolve_initial_references("ChainClientInterceptorFactory"));
            clientFactory.add(new SampleClientInterceptorFactory());
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName e)
        {
            throw new org.omg.CORBA.INITIALIZE("Client interceptor factory is not installed: " + e);
        }

        // install server interceptor factory
        try
        {
            com.visigenic.vbroker.interceptor.ChainServerInterceptorFactory serverFactory = com.visigenic.vbroker.interceptor.ChainServerInterceptorFactoryHelper.narrow(orb.resolve_initial_references("ChainServerInterceptorFactory"));
            serverFactory.add(new SampleServerInterceptorFactory());
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName e)
        {
            throw new org.omg.CORBA.INITIALIZE("Server interceptor factory is not installed: " + e);
        }
    }
}
