// TimerInterceptor.java

package timer;

import  com.visigenic.vbroker.interceptor.*;

public class TimerInterceptor
{
    public void print(String name, String msg, Object data)
    {
        print(name, msg, (TimerData)data, new TimerData());
    }

    protected void print(String name, String msg, TimerData start, TimerData end)
    {
        long        elapsed = end.elapsed(start);

        System.out.print(name + ": ");

        if (msg != null)    System.out.print("(" + msg + ") - ");

        if (elapsed > 1000) System.out.print(elapsed/1000 + " s, ");

        System.out.println(elapsed%1000 + " ms");
    }

    public void begin(Closure closure, String operation)
    {
        TimerData   t1 = new TimerData();
        TimerData   t2 = (TimerData)t1.clone();

        closure.object = new TwoTimerData(t1, t2, operation);
    }

    public void delta(Closure closure, String meaning)
    {
        TwoTimerData    t = (TwoTimerData)closure.object;
        TimerData       start = t.getStart2();
        TimerData       end = new TimerData();

        print(t.getOperation(), meaning, start, end);
        t.setStart2(end);
    }

    public void complete(Closure closure, String meaning)
    {
        TwoTimerData    t = (TwoTimerData)closure.object;

        print(t.getOperation(), meaning, t.getStart1(), t.getStart2());
        System.out.println();
    }
}
