// Server.java

public class Server {

  public static void main(String[] args) throws Exception {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);
    // Initialize the BOA.
    org.omg.CORBA.BOA boa = orb.BOA_init();
    // Create the account manager object.
    Bank.AccountManager manager = 
      new AccountManagerImpl("BankManager")._this();
    // Export the newly create object.
    boa.obj_is_ready(manager);
    System.out.println("AccountManager:BankManager is ready.");
    // Run the client's main program, to verify local behavior
    for( int i = 0; i < args.length; i++ ) {
      if( args[i].equals("-runCoLocated") ) {
	if( args[i+1].equalsIgnoreCase("Client") ){
	  Client.main(new String[0]);
	}
	else if( args[i+1].equalsIgnoreCase("TypedClient") ){
	  TypedClient.main(new String[0]);
	}
	if( args[i+1].equalsIgnoreCase("UntypedClient") ){
	  UntypedClient.main(new String[0]);
	}
	System.exit(1);
      }
    }
    // Wait for incoming requests
    boa.impl_is_ready();
  }
}

