// TypedClient.java
import com.visigenic.vbroker.interceptor.*;

public class TypedClient {

  public static void main(String[] args) throws Exception {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);
    // Add a typed object wrapper for Account objects
    Bank.AccountHelper.addClientObjectWrapperClass(orb, BankWrappers.CachingAccountObjectWrapper.class);
    // Locate an account manager.
    Bank.AccountManager manager = 
	Bank.AccountManagerHelper.bind(orb, "BankManager");

    // use args[0] as the account name, or a default.
    String name = args.length > 0 ? args[0] : "Jack B. Quick";
    // Request the account manager to open a named account.
    Bank.Account account = manager.open(name);
      // Get the balance of the account.
    float balance = account.balance();
    // Print out the balance.
    System.out.println
      ("The balance in " + name + "'s account is $" + balance);

    System.out.println("Pass two");
    balance = account.balance();
    System.out.println
      ("The balance in " + name + "'s account is $" + balance);

    // Attempting to connect to 'Unauthorized Account'
    try { 
      System.out.println("Trying Unauthorized Account");
      account = manager.open("Unauthorized Account");
    }catch( org.omg.CORBA.NO_PERMISSION e) {
      System.out.println("No permission to open this account");
    }
  }

}
