package UtilityObjectWrappers;

import java.util.*;
import com.visigenic.vbroker.orb.*;
import com.visigenic.vbroker.interceptor.*;

public class Init extends ServiceInit {
  com.visigenic.vbroker.orb.ORB _orb;

  public void init(org.omg.CORBA.ORB orb, Properties properties) {
    _orb = (ORB) orb;
    try {
      ChainUntypedObjectWrapperFactory Cfactory = 
	ChainUntypedObjectWrapperFactoryHelper.narrow
        (orb.resolve_initial_references("ChainClientUntypedObjectWrapperFactory"));
      ChainUntypedObjectWrapperFactory Sfactory = 
	ChainUntypedObjectWrapperFactoryHelper.narrow
        (orb.resolve_initial_references("ChainServerUntypedObjectWrapperFactory"));
      // install my Timing ObjectWrapper
      String val = properties.getProperty("Timing", this.toString());
      if( !val.equals(this.toString())) {
	UntypedObjectWrapperFactory f= new TimingUntypedObjectWrapperFactory();
	if( val.equalsIgnoreCase("client") ){
	  Cfactory.add(f);
	} else if( val.equalsIgnoreCase("server") ) {
	  Sfactory.add(f);
	} else {
	  Cfactory.add(f);
	  Sfactory.add(f);
	}
      }
      // install my Tracing ObjectWrapper
      val = properties.getProperty("Tracing", this.toString());
      if( !val.equals(this.toString())) {
	UntypedObjectWrapperFactory f= new TracingUntypedObjectWrapperFactory();
	if( val.equalsIgnoreCase("client") ){
	  Cfactory.add(f);
	} else if( val.equalsIgnoreCase("server") ) {
	  Sfactory.add(f);
	} else {
	  Cfactory.add(f);
	  Sfactory.add(f);
	}
      }
    } catch( org.omg.CORBA.ORBPackage.InvalidName e ) {
      return;
    }

  }
}
