// Server.java

import org.omg.CORBA.*;
import com.visigenic.vbroker.extension.*;
import db.*;

class DBObjectImpl extends _DBObjectImplBase {

  private String _name;

  DBObjectImpl(String name) {
    _name = name;
  }

  public String get_name() {
    return _name; 
  }

}

class DBImpl extends _DBImplBase {

  DBImpl(String name) {
    super(name);
  }
  
  public DBObject create_object(String name) {
    System.out.println("Creating: " + name);
    DBObject dbObject = new DBObjectImpl(name);
    int length = name.length(); 
    byte[] ref_data = new byte[length];
    name.getBytes(0, length, ref_data, 0);
    System.out.println("ref_data: ");
    _boa().obj_is_ready(dbObject, "DBService", ref_data);
    return dbObject;
  }

}

class DBActivator implements Activator {

  private static int _count;
  private org.omg.CORBA.BOA _boa; 

  public DBActivator(org.omg.CORBA.BOA boa) {
    _boa = boa;
  }

  public org.omg.CORBA.Object activate(ImplementationDef impl) {
    System.out.println("Activator called " + ++_count + " times");
    byte[] ref_data = ((ActivationImplDef) impl).id();
    DBObjectImpl obj = new DBObjectImpl(new String(ref_data, ref_data.length-1));
    _boa.obj_is_ready(obj);
    return obj;
  }
  
  public void deactivate(org.omg.CORBA.Object obj, ImplementationDef impl) {
    // nothing to do here...
  }

}

public class Server {

  public static void main(String[] args) {
    ORB orb = ORB.init(args,null);
    BOA boa = orb.BOA_init();
    DB db = new DBImpl("Database Manager");
    boa.obj_is_ready(db);
    boa.impl_is_ready("DBService", new DBActivator(boa));
  }

}
